## llvm-toolchain-20 20.1.0~+rc1

=== offload/test/CMakeLists.txt ===
# CMakeLists.txt file for unit testing OpenMP offloading runtime library.
if(NOT CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR
   CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6.0.0)
  message(STATUS "Can only test with Clang compiler in version 6.0.0 or later.")
  message(WARNING "The check-offload target will not be available!")
  return()
endif()

if(LIBOMPTARGET_ENABLE_DEBUG)
  set(LIBOMPTARGET_DEBUG True)
else()
  set(LIBOMPTARGET_DEBUG False)
endif()

if (NOT OPENMP_STANDALONE_BUILD AND "compiler-rt" IN_LIST LLVM_ENABLE_RUNTIMES)
  set(LIBOMPTARGET_TEST_GPU_PGO True)
else()
  set(LIBOMPTARGET_TEST_GPU_PGO False)
endif()

# Replace the space from user's input with ";" in case that CMake add escape
# char into the lit command.
string(REPLACE " " ";" LIBOMPTARGET_LIT_ARG_LIST "${LIBOMPTARGET_LIT_ARGS}")

find_package(CUDAToolkit QUIET)
if(CUDAToolkit_FOUND)
  get_filename_component(CUDA_ROOT "${CUDAToolkit_BIN_DIR}" DIRECTORY ABSOLUTE)
  get_filename_component(CUDA_LIBDIR "${CUDA_cudart_static_LIBRARY}" DIRECTORY)
endif()

set(OMP_DEPEND)
if(TARGET omp)
  set(OMP_DEPEND omp)
endif()

string(REGEX MATCHALL "([^\ ]+\ |[^\ ]+$)" SYSTEM_TARGETS "${LIBOMPTARGET_SYSTEM_TARGETS}")
foreach(CURRENT_TARGET IN LISTS SYSTEM_TARGETS)
  string(STRIP "${CURRENT_TARGET}" CURRENT_TARGET)

  add_offload_testsuite(check-libomptarget-${CURRENT_TARGET}
    "Running libomptarget tests"
    ${CMAKE_CURRENT_BINARY_DIR}/${CURRENT_TARGET}
    DEPENDS omptarget ${OMP_DEPEND} ${LIBOMPTARGET_TESTED_PLUGINS}
    ARGS ${LIBOMPTARGET_LIT_ARG_LIST})
  list(APPEND LIBOMPTARGET_LIT_TESTSUITES ${CMAKE_CURRENT_BINARY_DIR}/${CURRENT_TARGET})

  # Configure the lit.site.cfg.in file
  set(AUTO_GEN_COMMENT "## Autogenerated by libomptarget configuration.\n# Do not edit!")
  configure_file(lit.site.cfg.in ${CURRENT_TARGET}/lit.site.cfg @ONLY)
endforeach()


add_offload_testsuite(check-libomptarget
  "Running libomptarget tests"
  ${LIBOMPTARGET_LIT_TESTSUITES}
  EXCLUDE_FROM_CHECK_ALL
  DEPENDS llvm-offload-device-info omptarget ${OMP_DEPEND} ${LIBOMPTARGET_TESTED_PLUGINS}
  ARGS ${LIBOMPTARGET_LIT_ARG_LIST})

add_offload_testsuite(check-offload
  "Running libomptarget tests"
  ${LIBOMPTARGET_LIT_TESTSUITES}
  EXCLUDE_FROM_CHECK_ALL
  DEPENDS llvm-offload-device-info omptarget ${OMP_DEPEND} ${LIBOMPTARGET_TESTED_PLUGINS}
  ARGS ${LIBOMPTARGET_LIT_ARG_LIST})

=== debian/changelog ===
llvm-toolchain-20 (1:20.1.0~+rc1-1~exp1ubuntu2) plucky; urgency=medium

  * d/t/control.in: Remove explicit dependency on libstdc++-N-dev.
  * d/rules: Unset BD_ALT_HELLO, regenerate the control file.

 -- Matthias Klose <doko@debian.org>  Sun, 09 Feb 2025 09:06:41 +0100

llvm-toolchain-20 (1:20.1.0~+rc1-1~exp1) experimental; urgency=medium

  * First tag of 20.1.0
  * libLLVMOffload.so.20.0 => libLLVMOffload.so.20.1 to follow upstream change
  * Use lld as a linker instead of gold

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 03 Feb 2025 09:00:03 +0100

llvm-toolchain-20 (1:20~++20250130014317+8c2574832ed2-1~exp1) experimental; urgency=medium

  [ Matthias Klose ]
  * d/rules: Distinguish between openmp and offload architectures.
  * Update libclang1 symbols file.
  * Update libomp symbols file, using symvers.
  * d/t/control: Remove explicit dependency on libstdc++-N-dev.

  [ Sylvestre Ledru ]
  * Prepare the branch 20

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 30 Jan 2025 13:43:33 +0100

llvm-toolchain-snapshot (1:20~++20250107094038+ea14bdb0356c-1~exp1) experimental; urgency=medium

  [ Matthias Klose ]
  * bolt: Disable the check for /proc/self/map_files. Might not be available
    on build machines. LP: #2084316.
  * Fix compatibility with Python 3.13. Closes: #1084659.

  [ Sylvestre Ledru ]
  * New snapshot release
  * Install usr/lib/llvm-20/include/shared/rpc*.h in libllvmlibc-X.Y-dev

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 07 Jan 2025 21:41:10 +0100

llvm-toolchain-snapshot (1:20~++20241212011120+0cbdad4bd239-1~exp1) experimental; urgency=medium

  * Only build libc on supported arch (for real)
  * Ship bolt-binary-analysis in bolt

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 12 Dec 2024 13:22:30 +0100

llvm-toolchain-snapshot (1:20~++20241205084449+66a0a081338d-1~exp1) experimental; urgency=medium

  [ Matthias Klose ]
  * Build-depend on llvm-spirv-19 instead of llvm-spirv-18.
  * d/libclang-cppX.Y.links.in: Honor LLVM_VERSION_MINOR for the symlink.
  * Update watch file and add .git* files to exclude in the tarball.
  * d/rules: Add a BD_ALT_HELLO macro. Set it to anything else than "yes" to avoid
    generating alternative build dependencies on hello in the control file.

  [ Samuel Thibault ]
  * debian/libclang-common-X.Y-dev.install.in: Fix dh_install on hurd-any.

  [ John Paul Adrian Glaubitz ]
  * Don't try to install xray and profile headers on powerpc
  * Install liborc_rt-powerpc64.a on powerpc
  * Allow overriding the bootstrap compiler from the environment
  * Set compiler-rt default target arch on powerpc
  * Restrict compiler-rt build to default target arch on powerpc

  [ Sylvestre Ledru ]
  * experimental New snapshot release
  * flang-new has been renamed to flang (a flang-new still exists)
  * Use the | hello trick for g++-multilib for s390x / Ubuntu Oracular
  * Also install usr/lib/llvm-20/lib/libgomp.so.1 (links)
    Follow eccdb2489483ca58d2cb35bc38967a8e33117575
  * Ship fir-lsp-server in flang-20
  * Ship clang-sycl-linker in clang-tools
  * remove libLibcTableGenutil.a
    Removed in https://github.com/llvm/llvm-project/pull/117220/files
  * Ship liboffload in a new package

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 06 Dec 2024 18:14:31 +0100

llvm-toolchain-snapshot (1:20~++20241008102056+4d218caa7716-1~exp1) experimental; urgency=medium

  [ Matthias Klose ]
  * Build-depend on llvm-spirv-19 instead of llvm-spirv-18.
  * d/libclang-cppX.Y.links.in: Honor LLVM_VERSION_MINOR for the symlink.
  * Update watch file and add .git* files to exclude in the tarball.

  [ Samuel Thibault ]
  * debian/libclang-common-X.Y-dev.install.in: Fix dh_install on hurd-any.

  [ Sylvestre Ledru ]
  * New snapshot release
  * sync from 19 => snapshot

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 08 Oct 2024 10:21:13 +0200

llvm-toolchain-snapshot (1:20~++20240921071058+b177a9b6efb6-1~exp1) experimental; urgency=medium

  [ Matthias Klose ]
  * Add a .gitignore file with all toplevel upstream files and directories.
  * Add some memory tracking, getting some information on memory hogs.
  * Don't require g++-multilib on s390x for newer Ubuntu releases.
  * Factor-out ocaml architectures.
  * Don't try to install xray and profile headers on armel and armhf.
  * Disable ocaml on armhf, requires ocamlopt.
  * Factor-out omp architectures.
  * Disable openmp on riscv64 (ld: cannot find -lomptarget.rtl.host).
  * Factor-out flang architectures.
  * Disable flang on mips64el (currently not supported).
  * Don't try to install hwasan_symbolize on x32.
  * Don't try to install xray and profile headers on x32.
  * Fix installation of the shared libllvm and libclang-cpp libraries
    under their soname. Addresses: #1072200.
  * Drop some of the unnecessary libllvm symlinks.
  * debian/orig-tar.sh: Don't include .git/.github metadata.
  * debian/rules: Don't create a stamp for the override_dh_auto_install target.
  * debian/rules. Call again dh_ocaml. Closes: #1078235.
  * Disable openmp on mips64el (ld: cannot find -lomptarget.rtl.host).
  * Disable memory tracking on the Hurd and some ports architectures.
  * Also explicitly link with -latomic on mips64el.
  * Build without z3 on sh4 (ftbfs).
  * Also configure with -DLLVM_EXPERIMENTAL_TARGETS_TO_BUILD="M68k;Xtensa".
  * debian/qualify-clang.sh: Don't check for libclang-cpp.so.$VERSION symlink.
  * debian/tests/*: s/18/20/g.
  * libllvm20: Restore the symlink /usr/lib/llvm-20/lib/libLLVM.so.1, apparently
    CMake's LLVMExports.cmake requires it. But why?
  * Disable z3 again for Ubuntu, and make the libz3-dev (build) dependency
    conditional.
  * Use -mxgot on mips64el.
  * Disable tests on mips64el, they do timeout.
  * Consolidate disabling CMake's package validation checks a bit.
  * debian/qualify-clang.sh: Skip OpenMP test, if libomp-dev is not available.
  * Disable CMake's package validation check for libLLVM.so.1.
  * Disable the usage-wrapper/memory tracking by default.


=== debian/control ===
Source: llvm-toolchain-20
Section: devel
Priority: optional
Rules-Requires-Root: no
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>, Gianfranco Costamagna <locutusofborg@debian.org>
Build-Depends: debhelper (>= 10.0), cmake, ninja-build,
    chrpath, texinfo, sharutils,
    libelf-dev,
    libffi-dev,
    lsb-release, patchutils, diffstat, xz-utils, python3-dev,
    libedit-dev, libncurses-dev, swig, python3-sphinx (>= 1.3.6),
    binutils-dev, lld,
    libxml2-dev,
    libjsoncpp-dev, pkg-config,
    libipt-dev [amd64 i386],
    lcov, procps, help2man,
    zlib1g-dev, libzstd-dev,
    g++-multilib [amd64 i386 mips64 mips64el mipsel powerpc ppc64 sparc sparc64 x32],
    libjs-mathjax, python3-myst-parser | python3-recommonmark, python3-pexpect,
    doxygen, time,
    ocaml-base [amd64 arm64 ppc64el riscv64 s390x] | ocaml-nox [amd64 arm64 ppc64el riscv64 s390x],
    ocaml-findlib [amd64 arm64 ppc64el riscv64 s390x],
    libctypes-ocaml-dev [amd64 arm64 ppc64el riscv64 s390x],
    dh-exec, dh-ocaml [amd64 arm64 ppc64el riscv64 s390x],
    libpfm4-dev [linux-any], python3-setuptools, 
# "| hello" is for older buster/bionic distros without spirv support
# We need to keep the constraints coherent between the two alternatives, otherwise
# hello would get installed unexpectedly and prevent e.g. wasi-libc from getting pulled
    llvm-spirv-19 [amd64 arm64 armhf i386 ppc64 ppc64el riscv64 s390x] <!stage1>,
    spirv-tools [linux-any] <!stage1>,
    wasi-libc,
    libcurl4-openssl-dev <!stage1> | libcurl-dev <!stage1>,
    libgrpc++-dev [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x] <!stage1>,
    protobuf-compiler-grpc [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x] <!stage1>,
    libprotobuf-dev [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x] <!stage1>,
    protobuf-compiler [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x] <!stage1>,
Build-Conflicts: oprofile
Standards-Version: 4.7.0
Homepage: https://www.llvm.org/
Vcs-Git: https://salsa.debian.org/pkg-llvm-team/llvm-toolchain.git -b 20
Vcs-Browser: https://salsa.debian.org/pkg-llvm-team/llvm-toolchain/tree/20

# ------------- clang -------------

Package: clang-20
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 ${dep:devlibs-objc},
 libllvm20 (= ${binary:Version}),
 libclang-common-20-dev (= ${binary:Version}),
 llvm-20-linker-tools (= ${binary:Version}),
 libclang1-20 (= ${binary:Version}), libc6-dev, binutils
Provides: c-compiler, objc-compiler, c++-compiler, objc++-compiler
Recommends: llvm-20-dev, python3
# libomp-20-dev
Suggests: clang-20-doc, wasi-libc
Description: C, C++ and Objective-C compiler
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.

Package: clang-tools-20
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, clang-20 (= ${binary:Version}),
 python3
Description: clang-based tools for C/C++ developments
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains some clang-based tools like scan-build, clang-cl, etc.

Package: clang-format-20
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
 libllvm20 (= ${binary:Version})
Description: Tool to format C/C++/Obj-C code
 Clang-format is both a library and a stand-alone tool with the goal of
 automatically reformatting C++ sources files according to configurable
 style guides. To do so, clang-format uses Clang's Lexer to transform an
 input file into a token stream and then changes all the whitespace around
 those tokens. The goal is for clang-format to both serve both as a user
 tool (ideally with powerful IDE integrations) and part of other
 refactoring tools, e.g. to do a reformatting of all the lines changed
 during a renaming.
 .
 This package also provides vim and emacs plugins.

Package: clang-tidy-20
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
 libllvm20 (= ${binary:Version}),
 libclang-common-20-dev (= ${binary:Version}),
 clang-tools-20, python3-yaml
Description: clang-based C++ linter tool
 Provide an extensible framework for diagnosing and fixing typical programming
 errors, like style violations, interface misuse, or bugs that can be deduced
 via static analysis. clang-tidy is modular and provides a convenient interface
 for writing new checks.

Package: clangd-20
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libllvm20 (= ${binary:Version}),
 libclang-common-20-dev (= ${binary:Version}),
Description: Language server that provides IDE-like features to editors
 clangd understands your C++ code and adds smart features to your editor:
  - code completion
  - compile errors
  - go-to-definition
  - and more.
 .
 clangd is a language server that implements the Language Server Protocol;
 it can work with many editors through a plugin.

Package: clang-20-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-mathjax
Description: C, C++ and Objective-C compiler - Documentation
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the documentation.

Package: libclang1-20
Provides: ${t64:Provides}
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang library.
 .
 The C Interface to Clang provides a relatively small API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.

Package: libclang-20-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 ${dep:devlibs-objc}, libclang1-20 (= ${binary:Version}),
 libclang-common-20-dev (= ${binary:Version})
Description: Clang library - Development package
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang headers to develop extensions over
 libclang1-20.

Package: libclang-common-20-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends},
Recommends: libclang-rt-20-dev
Description: Clang library - Common development package
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang generic headers.

# ------------- compiler-rt -------------

Package: libclang-rt-20-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Compiler-rt - development package
 This package provides various libraries:
 .
   * builtins - Simple libraries that provide implementation of the
     low-level target-specific hooks required by code generation
     and other runtime components.
   * sanitizer runtimes - AddressSanitizer, ThreadSanitizer,
     UndefinedBehaviorSanitizer, MemorySanitizer, LeakSanitizer
     DataFlowSanitizer, etc
   * profile - Library which is used to collect coverage information.

Package: libclang-rt-20-dev-wasm32
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Compiler-rt - wasm32 builtins
 Provides the compiler-rt builtins for WebAssembly 32 bits

Package: libclang-rt-20-dev-wasm64
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Compiler-rt - wasm64 builtins
 Provides the compiler-rt builtins for WebAssembly 64 bits

# ------------- polly -------------

Package: libpolly-20-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: High-level loop and data-locality optimizer
 Uses an abstract mathematical representation based on integer polyhedra
 to analyze and optimize the memory access pattern of a program

# ------------- clang libraries -------------

Package: libclang-cpp20
Provides: ${t64:Provides}
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libllvm20 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: C++ interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang C++ library.
 .
 The C++ Interface to Clang provides an API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.

Package: libclang-cpp20-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 libclang-cpp20 (= ${binary:Version})
# Move of libclang-cpp.so into libclang-cpp20.dev
Description: C++ interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang C++ library.
 .
 The C++ Interface to Clang provides an API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.
 .
 This package contains symlinks without a version number, which needed by
 linker at build time.


Package: libfuzzer-20-dev
Architecture: linux-any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, clang-20 (= ${binary:Version})
Description: Library for coverage-guided fuzz testing
 LibFuzzer is a library for in-process, coverage-guided, evolutionary fuzzing
 of other libraries.
 .
 LibFuzzer is similar in concept to American Fuzzy Lop (AFL), but it performs
 all of its fuzzing inside a single process. This in-process fuzzing can be

=== debian/rules ===
#!/usr/bin/make -f

# polly & lldb aren't enabled for every platform
PROJECTS = clang;clang-tools-extra;lld;cross-project-tests;mlir
# openmp & libunwind aren't enabled for every platform

TARGET_BUILD	:= build-llvm
TARGET_BUILD_STAGE2    := $(TARGET_BUILD)/tools/clang/stage2-bins
DEB_INST		:= $(CURDIR)/debian/tmp/

GXX_VERSIONED_PACKAGE    := $(shell dpkg-query -W -f '$${Depends}' g++ | grep -o 'g++-[0-9][0-9.]*' | tail -n1 )
GXX_VERSIONED_EXECUTABLE := $(shell dpkg -L $(GXX_VERSIONED_PACKAGE) | grep '/usr/bin/g++-[0-9][0-9.]*' | xargs ls -d | tail -n1 )
GCC_VERSION              := $(subst /usr/bin/g++-,,$(GXX_VERSIONED_EXECUTABLE))

PKG_VERSION := $(shell dpkg-parsechangelog | awk '/^Version:/ {print $$2}')
LLVM_EPOCH := 1:
LLVM_VERSION   := $(shell echo $(PKG_VERSION) | sed -rne "s,^1:([0-9]+).*,\1,p")
LLVM_VERSION_FULL := $(shell echo $(PKG_VERSION) | sed -rne "s,^1:([0-9.]+)(~|-)(.*),\1,p")
LLVM_VERSION_MINOR := $(shell echo $(PKG_VERSION)  | sed -rne "s,^1:[0-9]+\.([0-9]+)\.[0-9]+.*,\1,p")
LLVM_VERSION_SNAPSHOT := $(shell echo $(PKG_VERSION) | sed -rne "s,^1:(.*),\1,p")
ifeq ($(LLVM_VERSION),$(LLVM_VERSION_FULL))
	LLVM_VERSION_FULL := $(LLVM_VERSION).0.0
	LLVM_VERSION_MINOR := 0
endif
LLVM_VERSION_NEXT := $(shell echo $(LLVM_VERSION_FULL) | awk -F. '{ OFS="."; $$NF+=1; print}')

# dpkg-buildflags support
# disable fixfilepath in favor of the llvm-project supplied flavor, disable lto
# remove +time64,+lfs once the time64_t transition starts
ifeq ($(DEB_HOST_ARCH),i386)
  RUNTIMES = compiler-rt;libcxx;libcxxabi
  export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto
else
  ifeq ($(DEB_HOST_ARCH_BITS),32)
    RUNTIMES = libcxx;libcxxabi
    export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto abi=+time64,+lfs
    skip_packages = -Nlibclang-rt-$(LLVM_VERSION)-dev
  else
    RUNTIMES = compiler-rt;libcxx;libcxxabi
    ifeq ($(DEB_HOST_ARCH),mips64el)
        export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto hardening=-stackprotector,-stackprotectorstrong
    else
        export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto
    endif
  endif
endif

SOURCE_NAME := $(shell dpkg-parsechangelog -S Source)
ifneq (,$(findstring snapshot,$(SOURCE_NAME)))
  BRANCH_NAME=snapshot
else
  BRANCH_NAME=$(LLVM_VERSION)
endif

VENDOR=$(shell lsb_release -is)
DISTRO=$(shell lsb_release -sc)
DERIVATIVE := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
		elif dpkg-vendor --derives-from Debian; then echo Debian; \
		else echo Unknown; fi)

SONAME_EXT      := 1
SONAME_OPENMP	:= 5
# Manage the case when the version is 3.5~svn213052-1~exp1 or 3.4.2-1
DEBIAN_REVISION := $(shell dpkg-parsechangelog |  sed -rne "s,^Version: 1:([0-9.]+)(~|-)(.*),\3,p")
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
	NCPUS := $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
else
	NCPUS := $(shell nproc)
endif

# set this macro to anything else than "yes" to avoid generating alternative
# build dependencies on hello in the control file.
#BD_ALT_HELLO = yes
ifeq ($(BD_ALT_HELLO),yes)
  BD_ALT_HELLO_SUBST = 's/@hb@//;s/@he@//'
else
  BD_ALT_HELLO_SUBST = 's/@hb@.*@he@//'
endif

# this contains all packages to be built. Note that for at least the clean target,
# this always includes the binary-indep packages.
packages := $(shell dh_listpackages)

# no 32bit support
FLANG_ARCHS := amd64 arm64 ppc64el ppc64 sparc64 riscv64 loong64

# flang has some memory hogs, of up to 6.2gb per process. Limit the parallel jobs
# based on the available memory
ifneq (,$(filter $(DEB_HOST_ARCH), $(FLANG_ARCHS)))
  MEM_PER_CPU=6000
else
  MEM_PER_CPU=2100
endif

NJOBS := $(shell mt=`awk '/^(MemAvail|SwapFree)/ { mt += $$2 } END {print mt}' /proc/meminfo`; \
		awk -vn=$(NCPUS) -vmt=$$mt -vm=$(MEM_PER_CPU) \
		  'END { mt/=1024; n2 = int(mt/m); print n==1 || n2<=1 ? 1 : n2<=n ? n2 : n }' < /dev/null)

TIME_COMMAND = $(CURDIR)/debian/usage-wrapper.py $(SUMMARY_ONLY) -j $(NJOBS) --base-memory -m 4.0 -o usage-$(notdir $@)-$(DEB_HOST_ARCH).svg
TIME_BIN := $(if $(wildcard /usr/bin/time),/usr/bin/time,/bin/time)
TIME_COMMAND = $(TIME_BIN) -v
USAGE_BUILD_DEP = $(EMPTY) time,
ifneq (,$(findstring usage-wrapper, $(TIME_COMMAND)))
  ifeq ($(DERIVATIVE),Ubuntu)
    USAGE_BUILD_DEP = $(EMPTY) python3:any, python3-psutil, python3-matplotlib [!i386],
    ifeq ($(DEB_HOST_ARCH),i386)
      SUMMARY_ONLY = --summary-only
    endif
  else
    USAGE_BUILD_DEP = $(EMPTY) python3:any, python3-psutil [!hurd-i386 !hurd-amd64], python3-matplotlib [!m68k !sh4 !x32 !hurd-i386 !hurd-amd64],
    ifneq (,$(filter $(DEB_HOST_ARCH), hurd-i386 hurd-amd64))
      TIME_COMMAND = $(TIME_BIN) -v
    endif
    ifneq (,$(filter $(DEB_HOST_ARCH), m68k sh4 x32))
      SUMMARY_ONLY = --summary-only
    endif
  endif
endif

DH_VERSION := $(shell dpkg -s debhelper | grep '^Version' | awk '{print $$2}')

include /usr/share/dpkg/architecture.mk

MULTILIB_ARCHS := amd64 i386 mips64 mips64el mipsel powerpc ppc64 s390x sparc sparc64 x32
ifeq ($(DERIVATIVE),Ubuntu)
  ifeq (,$(filter $(DISTRO), bionic focal jammy noble))
    MULTILIB_ARCHS := $(filter-out s390x, $(MULTILIB_ARCHS))
  endif
endif

CONFIGURE_EXTRA =

# these are handled on a per stage / build basis
ifeq ($(VENDOR)-$(DEB_HOST_ARCH),Ubuntu-ppc64el)
  export DEB_CFLAGS_MAINT_STRIP = -g -O3
  export DEB_CXXFLAGS_MAINT_STRIP = -g -O3
else
  export DEB_CFLAGS_MAINT_STRIP = -g -O2
  export DEB_CXXFLAGS_MAINT_STRIP = -g -O2
endif
include /usr/share/dpkg/buildflags.mk

# Remove -Bsymbolic-functions for causing:
# https://github.com/llvm/llvm-project/issues/59432#issuecomment-2500694332
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
ifneq (,$(LDFLAGS))
  LDFLAGS := $(filter-out %-Bsymbolic-functions,$(LDFLAGS))
endif
endif

# We use a stage2 build. It means that a first clang is built using gcc,
# a second clang is built with the first
# And the various components are built using the second clang.
# See https://llvm.org/docs/AdvancedBuilds.html

# collect additional flags for all stages all builds
CFLAGS_EXTRA = -Wno-unused-command-line-argument
CXXFLAGS_EXTRA = -Wno-unused-command-line-argument
LDFLAGS_EXTRA = -Wl,--build-id

# collect all flags for stage 1 toolchain build only
STAGE_1_CFLAGS = $(CFLAGS) $(CFLAGS_EXTRA) $(CPPFLAGS)
STAGE_1_CXXFLAGS = $(CXXFLAGS) $(CXXFLAGS_EXTRA) $(CPPFLAGS)
STAGE_1_LDFLAGS = $(LDFLAGS) $(LDFLAGS_EXTRA)
# If we build with libc++, we might want to set different arguments for
# stage 1 & runtimes
RUNTIMES_CFLAGS = $(STAGE_1_CFLAGS)
RUNTIMES_CXXFLAGS := $(STAGE_1_CXXFLAGS)
RUNTIMES_LDFLAGS := $(STAGE_1_LDFLAGS)

# collect all flags for stage 2 toolchain and stand-alone builds
STAGE_2_CFLAGS = $(CFLAGS) $(CFLAGS_EXTRA) $(CPPFLAGS)
STAGE_2_CXXFLAGS = $(CXXFLAGS) $(CXXFLAGS_EXTRA) $(CPPFLAGS)
STAGE_2_LDFLAGS = $(LDFLAGS) $(LDFLAGS_EXTRA)

# collect additional cmake options for toolchain build configuration
STAGE_1_CMAKE_EXTRA =
STAGE_2_CMAKE_EXTRA =
STAGE_ALL_CMAKE_EXTRA =
# toolchain config-only var combining all stage 1 cmake options
CMAKE_EXTRA = $(STAGE_1_CMAKE_EXTRA) $(STAGE_ALL_CMAKE_EXTRA)
# toolchain config-only var prepending BOOTSTRAP_ to all stage 2 cmake options
BOOTSTRAP_CMAKE_EXTRA = $(foreach extra,$(STAGE_2_CMAKE_EXTRA) $(STAGE_ALL_CMAKE_EXTRA), $(subst -D,-DBOOTSTRAP_,$(extra)))

BASE_PATH := $(CURDIR)
STAGE_1_BIN_DIR := $(BASE_PATH)/$(TARGET_BUILD)/bin
STAGE_1_LIB_DIR := $(BASE_PATH)/$(TARGET_BUILD)/lib
STAGE_2_BIN_DIR := $(BASE_PATH)/$(TARGET_BUILD_STAGE2)/bin
STAGE_2_LIB_DIR := $(BASE_PATH)/$(TARGET_BUILD_STAGE2)/lib

# toggleable defaults
COMPILER_RT_USE_BUILTINS_LIBRARY := ON
LIBCXX_EXCEPTIONS := ON
LIBCXX_USE_COMPILER_RT := ON

# We want to set the clang extra version ONLY in stage 2
# because we want the clang stage 1 to be as reproducible as possible
# when building with sccache (because this tool do a hash using the

=== debian/tests/control ===
Test-Command: bash -v ./debian/qualify-clang.sh
Depends: @, cmake, make, g++, file, dpkg-dev
# Comment the dbgsym package because of bug #917528
# dbgsym packages not being available in testing
# clang-20-dbgsym, libclang1-20-dbgsym
Restrictions: allow-stderr
Architecture: amd64 arm64 i386

Tests: integration-test-suite-test
Depends: @, cmake, make, g++
Restrictions: allow-stderr
Architecture: amd64 arm64

Tests: cmake-llvm-test
Depends: gcc, build-essential, cmake, llvm-20-dev

Tests: cmake-clang-test
Depends: gcc, build-essential, cmake, llvm-20-dev, clang-20, libclang-20-dev

Test-Command: python3 -c "import lldb; print(lldb.__file__); print(lldb)"
Depends: python3-lldb-20
Architecture: amd64 arm64 armel armhf i386 ppc64el riscv64 s390x

Test-Command: python3 -c "import clang; print(clang.__file__); print(clang)"
Depends: python3-clang-20

## llvm-toolchain-20 20.1.0~+rc2

=== debian/changelog ===
llvm-toolchain-20 (1:20.1.0~+rc2-1~exp2ubuntu0.5) plucky; urgency=medium

  * d/control.in: clang-X.Y: Depend on binutils-gold.
  * d/rules: dh_ocaml: Temporarily override to help migration.
  * debian/llvm-X.Y-linker-tools.links.in: Restore while building with gold.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2025 15:26:02 +0100

llvm-toolchain-20 (1:20.1.0~+rc2-1~exp2ubuntu0.4) plucky; urgency=medium

  * Merge with Debian; remaining changes:
    - d/rules: Unset BD_ALT_HELLO, regenerate the control file.
  * Keep building with binutils-gold for now. Known to work.
  * Restore the fix-cmake-libc patch.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 14 Feb 2025 19:36:18 +0100

llvm-toolchain-20 (1:20.1.0~+rc2-1~exp2) UNRELEASED; urgency=medium

  [ Sylvestre Ledru ]
  * clang-20 recommends clang-tools-20
    https://github.com/llvm/llvm-project/issues/117333

  [ Matthias Klose ]
  * d/llvm-X.Y-linker-tools.links.in: Remove, no gold anymore. LP: #2098355.
  * d/rules: Simplify permission settings for generated debhelper files.
  * d/rules: There's no more CMakeOutput.log anymore.
  * d/libomp5-X.Y.symbols.in: Remove duplicate symbol.
  * d/rules: Update setting lld and gold archs.
  * d/rules: Don't use lld on ppc64, sparc64 and x32, apparently unsupported.
  * d/libclang-rt-X.Y-dev.install.in: Install liborc_rt* on loong64.
  * debian/patches/env-lld-package-metadata.diff: Update and re-enable.

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 14 Feb 2025 12:28:14 +0100

llvm-toolchain-20 (1:20.1.0~+rc2-1~exp1) experimental; urgency=medium

  [ Matthias Klose ]
  * d/t/control.in: Remove explicit dependency on libstdc++-N-dev.

  [ Sylvestre Ledru ]
  * new rc release
  * Disable env-lld-package-metadata.diff because of upstream changes

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 12 Feb 2025 13:23:30 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
     libffi-dev,
     lsb-release, patchutils, diffstat, xz-utils, python3-dev,
     libedit-dev, libncurses-dev, swig, python3-sphinx (>= 1.3.6),
-    binutils-dev, lld,
+    binutils-dev, lld [loong64] | binutils-gold [amd64 arm64 armhf i386 ppc64 ppc64el x32 s390x hurd-i386 hurd-amd64],
     libxml2-dev,
     libjsoncpp-dev, pkg-config,
     libipt-dev [amd64 i386],
@@ -50,9 +50,9 @@
  libllvm20 (= ${binary:Version}),
  libclang-common-20-dev (= ${binary:Version}),
  llvm-20-linker-tools (= ${binary:Version}),
- libclang1-20 (= ${binary:Version}), libc6-dev, binutils
+ libclang1-20 (= ${binary:Version}), libc6-dev, binutils, binutils-gold [amd64 arm64 armhf i386 ppc64 ppc64el x32 s390x hurd-i386 hurd-amd64]
 Provides: c-compiler, objc-compiler, c++-compiler, objc++-compiler
-Recommends: llvm-20-dev, python3
+Recommends: llvm-20-dev, python3, clang-tools-20
 # libomp-20-dev
 Suggests: clang-20-doc, wasi-libc
 Description: C, C++ and Objective-C compiler
@@ -293,5 +293,3 @@
  LibFuzzer is a library for in-process, coverage-guided, evolutionary fuzzing
  of other libraries.
  .
- LibFuzzer is similar in concept to American Fuzzy Lop (AFL), but it performs
- all of its fuzzing inside a single process. This in-process fuzzing can be
